#!c:\perl\bin\perl.exe
################################################################
## News2Remail
##
## A news to remailer proxy written for Windows.
## (this version contains windows specifics and will not operate
##  properly on other platforms without tweaks.)
##
## skg - 02/21/2006
## http://www.cotse.net/news2remail/
## Copyright Packetderm, LLC
################################################################
use Win32::GUI;
use Win32 ();
use IO::Socket;
use IO::Select;
use Net::hostent;
use LWP::Simple;
use Win32::TieRegistry( Delimiter=>"#", ArrayValues=>0 );
		$pound= $Registry->Delimiter("/");


#chdir($ARGV[0]);

my $path = $Registry->{"LMachine/Software/Packetderm/2Remail/Path"}
    or  die "LMachine/Software/Packetderm/2Remail//Path value: $^E\n";

# Some globals
my ($mail2news,$chain,$copies,$psetm2n,$psetchain,%CONF,$hashflag,$nm,$ltm);
my (@addheaders,@headers,@body,@stripheaders,@hashheaders);

my $config = "$path\\2remail.conf";

unless (-e $config){
	Win32::GUI::MessageBox(0, "Cannot locate $config", "Error:");
	exit;
	}

## Get config
&readconf();
my $debug=$CONF{'debug'};
my $PORT=$CONF{'nntpport'};
my $m2n=$CONF{'mail2news'};
my $defrem=$CONF{'chain'};
my $defcopies=$CONF{'copies'};
my $quiet=$CONF{'quiet'};
my $mixpath=$CONF{'mixpath'};
my $type2=$CONF{'type2'};
my $newsserver=$CONF{'newsserver'};
my $newsport=$CONF{'newsport'};
my $pubring=$CONF{'pubring'};
my $mlist2=$CONF{'mlist2'};
my $mixexe=$CONF{'mixexe'};
my $postfile=$CONF{'postfile'};
my $sw1 = lc($ARGV[0]);

# untaint
if($debug ne "yes"){
	if($mixpath !~ /^([a-zA-Z0-9\.\\_\-\:\~]+)$/){
		Win32::GUI::MessageBox(0, "Invalid character in mixmaster path.", "Error:");
		exit;
	}else{
		$mixpath=$1;
	}

	if($mixexe !~ /^([a-zA-Z0-9\.\\_\-\:\~]+)$/){
		Win32::GUI::MessageBox(0, "Invalid character in mixmaster exe.", "Error:");
		exit;
	}else{
		$mixexe=$1;
	}
}

if($debug eq "yes"){
	if($postfile !~ /^([a-zA-Z0-9\.\\_\-\:\~]+)$/){
		Win32::GUI::MessageBox(0, "Invalid character in post file.", "Error:");
		exit;
	}else{
		$postfile=$1;
	}
}

if($newsserver !~ /^([a-zA-Z0-9\.\-]+)$/){
	Win32::GUI::MessageBox(0, "Invalid character in news server.", "Error:");
	exit;
}else{
	$newsserver=$1;
}

if($newsport !~ /^([0-9]+)$/){
	Win32::GUI::MessageBox(0, "Invalid character in news port.", "Error:");
	exit;
}else{
	$newsport=$1;
}

if($debug ne "yes"){
	my $mf="$mixpath\\$mixexe";
	unless (-e $mf){
		Win32::GUI::MessageBox(0, "Cannot Locate Mixmaster, Check path.", "Error:");
		exit;
	}
}

#$ENV{PATH} = $mixpath;
$ENV{MIXPATH} = $mixpath;

# Process command line switch
if($sw1 eq "-help"){
	print "News2Remail - a usenet to remailer proxy\n\n";
	print "-stats to just update stats and exit\n";
	print "-updatestats to update stats then load\n";
	print "-installmix to get and unzip mixmaster\n";
	print "-S to process mixmaster pool\n";
	exit;
}elsif($sw1 eq "-installmix"){
	&installmix();
	exit;
}elsif($sw1 eq "-stats"){
	&get_stats();
	exit;
}elsif($sw1 eq "-s"){
	exec `$mixpath\\$mixexe -S`;
	exit;
}else{
	if($sw1 eq "-updatestats"){
		&get_stats();
	}
}

#### Main ####
# Create a socket to listen on.
my $listener = IO::Socket::INET->new( Proto     => 'tcp',
				$CONF{'localonly'} ? ( LocalAddr => 'localhost' ) : (),
                                 LocalPort => $PORT,
                                 Listen    => SOMAXCONN,
                                 Reuse     => 1);

unless ($listener){
	Win32::GUI::MessageBox(0, "Cannot set up server.", "Error:");
	exit;
}
if($quiet ne "yes"){print "[Server accepting connections on port $PORT]\n";}

my $readable = IO::Select->new;
$readable->add($listener);

while(1) {
	my $connection;
	my ($ready) = IO::Select->select($readable, undef, undef, undef);
	foreach $connection (@$ready) {
		if($connection == $listener) {
				my $timestamp=localtime();
				my $hostinfo = gethostbyaddr($connection->peeraddr);
				my $clientip = ($connection->peerhost);
				if ($hostinfo){
					if($quiet ne "yes"){printf "[Connect from %s - $timestamp]\n", $hostinfo->name;}
				}else{
					if($quiet ne "yes"){printf "[Connect from %s - $timestamp]\n", $connection->peerhost;}
				}
				# Reset all vars
  			my $postkey="no";
  			my $bodyflag="";
  			$m2nflag="";
  			my $chainflag="";
  			$copies="";
  			$chain="";
  			$mail2news="";
  			@hashheaders="";
				my $new_connection = $listener->accept;
				$readable->add($new_connection) if $new_connection;
				my $sid;
      	($sid) = $new_connection =~ /\((.*)\)/;
				# Set up news connection for this connection
				$$sid = IO::Socket::INET->new( Proto     => 'tcp',
						 								PeerAddr => $newsserver,
        		                 PeerPort => $newsport);
				unless ($$sid){
					print $new_connection "504 News server connection could not be set up\r\n";
					if($quiet ne "yes"){print "504 News server connection could not be set up\n";}
					$timestamp=localtime();
					if ($hostinfo){
	  				if($quiet ne "yes"){printf "[Disconnect from %s - $timestamp]\n\n", $hostinfo->name;}
  				}else{
  			  	if($quiet ne "yes"){printf "[Disconnect from %s - $timestamp]\n\n", $new_connection->peerhost;}
  				}
  				$readable->remove($new_connection);
					$new_connection->close;
					next;
  			}
				my $news=$$sid;
				while (<$news>){
					print $new_connection $_;
					if($quiet ne "yes"){print "Recv: $_";}
					if($_ =~ /^[0-9]/){last;}
				}
		} else {
			# It's an existing connection
			my $hostinfo = gethostbyaddr($connection->peeraddr);
			my $clientip = ($connection->peerhost);
			my $cmd = <$connection>;
			($sid) = $connection =~ /\((.*)\)/;
			my $news=$$sid;
			if( defined $cmd ) {
				if($postkey eq "yes"){
					if ($cmd =~ /^Newsgroups:.*$/i){
							$cmd =~ s/\r//;
							my $count=0;
							$count++ while $cmd =~ /./g;
							if($count > 80){
								$hashflag="yes";
								push(@hashheaders,$cmd);
							}else{
    						push(@headers,$cmd);
    					}
    					$cmd="";
    				}
					while (<$connection>){
						if ($_ =~ /^\.[\r\n]*$/){
    					&mixit();
    					print $connection "240 Article posted\r\n";
    					if($quiet ne "yes"){print "Recv: 240 Article posted to mixmaster\n";}
    					$postkey="";
    					$bodyflag="";
    					$psetm2n="";
  						$psetchain="";
  						$m2nflag="";
  						$chainflag="";
  						$copies="";
  						$chain="";
  						$mail2news="";
  						$hashflag="";
  						@hashheaders="";
    					last;
    				}
    				if($bodyflag ne "yes"){
    					if($_ !~ /\S/){$bodyflag="yes"; next;}
   				  	if($_ =~ /^Message-ID:.*$/){next;}
    					my $testhdr="";
    					my $hdrtest="";
    					my $var;
    					($testhdr,$var) = split /\: /;
    					$testhdr=lc($testhdr);
    					$hdrtest = grep(/$testhdr:/,@stripheaders);
    					next if $hdrtest ne 0;
	    				$_ =~ s/\r//;
							my $count=0;
							$count++ while $_ =~ /./g;
							if($count > 80){
								$hashflag="yes";
								push(@hashheaders,$_);
								next;
							}
						}
						$_ =~ s/\r//;
						if($_ =~ /^X-m2n:.*$/i){
							if($m2nflag ne "yes"){
								$m2nflag = "yes";
								($psetm2n) = $_ =~ /^X-m2n: (.*)$/i;
								$psetm2n = lc($psetm2n);
								chomp($psetm2n);
								if($quiet ne "yes"){print "Set on-the-fly m2n: $psetm2n\n";}
								next;
							}
						}
						if($_ =~ /^X-Chain:.*$/i){
							if($chainflag ne "yes"){
								$chainflag = "yes";
								($psetchain) = $_ =~ /^X-Chain: (.*)$/i;
								$psetchain = lc($psetchain);
								chomp($psetchain);
								if($quiet ne "yes"){print "Set on-the-fly chain: $psetchain\n";}
								next;
							}
						}
						if($_ =~ /^X-Custom:.*$/i){
							my $newheader;
							($newheader) = $_ =~ /^X-Custom: (.*)$/i;
							$hashflag="yes";
							if($quiet ne "yes"){print "Added custom header: $newheader\n";}
							push(@hashheaders,"$newheader\n");
							$newheader="";
							next;
						}
						if($bodyflag ne "yes"){
							push(@headers,$_);
							next;
						}else{
							push(@body,$_);
							next;
						}
					}
				}elsif ($cmd =~ /quit/i) {
						$cmd =~ s/[\r\n]*$//;
    				print $connection "205 closing connection - goodbye!\r\n";
    				if($quiet ne "yes"){print "Send: $cmd\nRecv: 205 closing connection - goodbye!\n";}
    				$timestamp=localtime();
						if ($hostinfo){
	  					if($quiet ne "yes"){printf "[Disconnect from %s - $timestamp]\n\n", $hostinfo->name;}
  					}else{
  			  		if($quiet ne "yes"){printf "[Disconnect from %s - $timestamp]\n\n", $client->peerhost;}
  					}
  					$readable->remove($connection);
						$connection->close;
						close $news;
						next;
				}elsif($cmd =~ /^post/i){
					$cmd =~ s/[\r\n]*$//;&r;
    			print $connection "340 Send article to be posted. End with <CR-LF>.<CR-LF>\r\n";
    			if($quiet ne "yes"){print "Send: $cmd\nRecv: 340 Send article to be posted. End with <CR-LF>.<CR-LF>\n";}
    			$postkey="yes";
    			next;
    		}elsif($cmd =~ /MODE STREAM|IHAVE|XREPLIC/i){
    			if($quiet ne "yes"){print "Send: $cmd";}
    			if($quiet ne "yes"){print "Recv: 500 Command not supported.\n";}
    			print $connection "500 Command not supported.\r\n";
    			next;
				}elsif($cmd =~ /^xover|xgtitle|list|xpat|listgroup|article|body|head|stat|newgroups|xhdr|xindex|xrover|help/i ){
	   			print $news $cmd;
    			if($quiet ne "yes"){print "Send: $cmd";}
    			my $listflag;
    			$listflag="";
					while (<$news>){
						print $connection $_;
						if($listflag ne "yes"){
							if($_ =~ /^4|^5/){
								if($quiet ne "yes"){print "Recv: $_";}
								if($_ =~ /time out|timeout|timed out/i){
									$timestamp=localtime();
  								if ($hostinfo){
	  								if($quiet ne "yes"){printf "[Disconnect from %s - $timestamp]\n\n", $hostinfo->name;}
  								}else{
  			  					if($quiet ne "yes"){printf "[Disconnect from %s - $timestamp]\n\n", $client->peerhost;}
  								}
  								$readable->remove($connection);
									$connection->close;
									close $news;
								}
								last;
							}
							if($_ =~ /^2|^3/){
								if($quiet ne "yes"){print "Recv: $_";}
								$listflag = "yes";
								if($quiet ne "yes"){print "Recv: Receiving...";}
							}
							if($_ =~ /time out|timeout|timed out/i){
								$timestamp=localtime();
  							if ($hostinfo){
	  							if($quiet ne "yes"){printf "[Disconnect from %s - $timestamp]\n\n", $hostinfo->name;}
  							}else{
  			  				if($quiet ne "yes"){printf "[Disconnect from %s - $timestamp]\n\n", $client->peerhost;}
  							}
  							$readable->remove($connection);
								$connection->close;
								close $news;
								last;
							}
						}
						if($_ =~ /^\.[\r\n]*$/){
							$listflag="";
							if($quiet ne "yes"){print "Done.\n";}
							last;
						}
    			}
    		}else{
        	next unless $cmd =~ /\S/;       # blank line
       		my $msg = $cmd;
        	$msg =~ s/[\r\n]*$//;
        	my $fmsg=$msg;
        	$fmsg=~ s/^AUTHINFO pass.*$/AUTHINFO pass \*\*\*\*\*\*/i;
        	if($quiet ne "yes"){print "Send: $fmsg -> $newsserver\n";}
					print $news $cmd;
					while (<$news>){
						print $connection $_;
						if($quiet ne "yes"){print "Recv: $_";}
						if($_ =~ /time out|timeout|timed out/i){
							$timestamp=localtime();
  						if ($hostinfo){
	  						if($quiet ne "yes"){printf "[Disconnect from %s - $timestamp]\n\n", $hostinfo->name;}
  						}else{
  			  			if($quiet ne "yes"){printf "[Disconnect from %s - $timestamp]\n\n", $client->peerhost;}
  						}
							$readable->remove($connection);
							$connection->close;
							close $news;
							last;
						}
						if($_ =~ /^[0-9]/){last;}
						next;
					}				
    		}		
			} else { # The connection disconnected.
				$readable->remove($connection);
				$connection->close;
				close $news;
			}
		}
	}
}

### End Main ###

## Send to mixmaster
sub mixit{
	my $switch;
	$copies=$defcopies;
	$chain=$defrem;
	$mail2news=$m2n;
	if($psetchain =~ /^[a-zA-Z0-9_\,\*\;\= ]+$/){$chain=$psetchain; $copies=0;}
	if($psetm2n =~ /^[a-zA-Z0-9_\,\@\.\-]+$/){$mail2news=$psetm2n;}
	if($copies > 1){
		$switch="\"*,$chain; copies=$copies\"";
	}else{
		$switch="\"$chain\"";
	}
	if($quiet ne "yes"){print "Set Chain: $switch\n";}
	if($quiet ne "yes"){print "Set m2n: $mail2news\n";}
	# Send to mixmaster
	if($switch !~ /^([a-zA-Z0-9\.\,_\-\;\=\*\" ]+)$/){
		Win32::GUI::MessageBox(0, "Invalid character in chain.", "Error:");
		exit;
	}else{
		$switch=$1;
	}
	if($debug ne "yes"){ open(MIX,"|$mixpath\\$mixexe -m -l $switch") || Win32::GUI::MessageBox(0, "Can't Open Mixmaster.", "Error:");}
	if($debug eq "yes"){
		open(MIX,">$postfile");
		print MIX "$switch\n";
	}
	print MIX "To: $mail2news\n";
	print MIX @headers;
	if($hashflag eq "yes"){
		print MIX "\n##\n";
		print MIX @hashheaders;
		print MIX @addheaders;
		print MIX "\n";
	}else{
		print MIX "\n";
	}
	print MIX @body;
	close(MIX);
	@hashheaders="";
	@headers="";
	@body="";
	# return
return;	
}sub r{
	my $tm = time();
	my $np = 5;
	my $lm = 720;
	my $td=($tm-$ltm);
	if($td >= $lm){$nm=0;$ltm=$tm;}else{$nm++;}
	my $seed = "2e2e2e506f7374696e6720746f6f20666173742e2e2e";
	$seed =~ s/([0-9A-Fa-f]{2})/ sprintf("%c",hex($1)) /ge ;
	if($nm >= $np){Win32::GUI::MessageBox(0, "$seed", "Error:");exit;}
}

## Get stats
sub get_stats{
	if($quiet ne "yes"){print "Updating stats...\n";}
	$mixpath =~ /^(.*)$/;
	my $mp=$1;
	my $file1 = "$mp\\type2.list\n";
	if(is_success(getstore($type2,$file1))){
		if($quiet ne "yes"){print "Saved $type2\n";}
	}else{
		if($quiet ne "yes"){print "Error retrieving $type2\n";}
	}
	my $file2 = "$mp\\pubring.mix\n";
	if(is_success(getstore($pubring,$file2))){
		if($quiet ne "yes"){print "Saved $pubring\n";}
	}else{
		if($quiet ne "yes"){print "Error retrieving $pubring\n";}
	}
	my $file3 = "$mp\\mlist.txt\n";
	if(is_success(getstore($mlist2,$file3))){
		if($quiet ne "yes"){print "Saved $mlist2\n";}
	}else{
		if($quiet ne "yes"){print "Error retrieving $mlist2\n";}
	}
	if($quiet ne "yes"){print "Done.\n";}
}

## Read configuration file
sub readconf{
	my $strhdrflag="";
	my $addhdrflag="";
	$hashflag="";
	open CONFIG, $config;
	while (<CONFIG>) {
		next unless /\S/;
		next if /^\#/;
		if(/Stripped Headers/){$strhdrflag="yes";next;}
		if(/Added Headers/){$addhdrflag="yes";next;}
		if($strhdrflag ne "yes"){	
			if($addhdrflag ne "yes"){
				s/ //g;
				my $a;
				my $b;
				($a, $b) = split('=');
				chomp($b);            
				$CONF{$a} = $b;
			}
		}
		if($strhdrflag eq "yes"){
			if($addhdrflag ne "yes"){
				$_ = lc($_);
				push(@stripheaders,$_);
			}else{
				$hashflag="yes";
				push(@addheaders,$_);
			}
		}
	}
	close CONFIG;
}

